#include <stdlib.h>
#include <stdio.h>

/* Include the Lua API header files. */
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>

int main(void)
{


	/* Declare a Lua State, open the Lua State and load the libraries (see above). */
	lua_State *l;
	l = lua_open();

	luaL_openlibs(l);

	/* print some text directly from C. */
	printf("This line in directly from C\n\n");

	luaL_dostring(l,"print 'Helloworld inside LUA '");
	/* In the lines below, I load and run the Lua code contained in the file */
	/* "script.lua". */
	luaL_dofile(l, "script.lua");
	printf("\nBack to C again\n\n");

	/* Remember to destroy the Lua State */
	lua_close(l);

	return 0;
}

