;;Assemble with:
;;nasm -fobj HelloLua_nagoa.asm
;;Link with:
;;alink -c -oPE -subsys con HelloLua_nagoa.obj

%include "nagoa+.inc"
;;LUA include files
%include "lua.inc"
%include "lauxlib.inc"
%include "lualib.inc"

;;IMPORTS
extern luaL_newstate
import luaL_newstate lua51.dll

extern luaL_loadstring
import luaL_loadstring lua51.dll

extern lua_pcall
import lua_pcall lua51.dll

extern luaL_loadfile
import luaL_loadfile lua51.dll

extern luaL_openlibs
import luaL_openlibs lua51.dll

extern lua_close
import lua_close lua51.dll

extern GetStdHandle
import GetStdHandle kernel32.dll
extern WriteFile
import WriteFile kernel32.dll
extern ExitProcess
import ExitProcess kernel32.dll

global ..start

segment .data USE32

message:    db      'Hello, World - Inside NASM', 10
MSGLEN equ $-message

funcname db "base",0

segment .bss USE32

byteswritten resd 1
lptr resd 1

segment .code USE32 class=code

..start:
    
    ; hStdOut = GetstdHandle( STD_OUTPUT_HANDLE)
    call    GetStdHandle,STD_OUTPUT_HANDLE
    
    ; WriteFile( hstdOut, message, length(message), &bytes, 0);
    call    WriteFile,eax,message,MSGLEN,byteswritten,0

    call luaL_newstate
    mov [lptr], eax

    call luaL_openlibs,[lptr]
    add esp,4
    
    call luaL_loadstring,[lptr],"print 'HelloWorld- Inside LUA'"
    add esp,8
    
    call lua_pcall,[lptr],0,LUA_MULTRET,0
    add esp,16

    call luaL_loadfile,[lptr],"script.lua"
    add esp,8
    
    call lua_pcall,[lptr],0,LUA_MULTRET,0
    add esp,16

    call lua_close,[lptr]
    add esp,4

    ; ExitProcess(0)
    call    ExitProcess,0

